﻿#include<iostream>
#include<list>
#include<algorithm>
#include <map>
#include<cmath>
struct data
{
	std::string name;
	double tall ;
	std::string size;
	double difference;
} typedef data;

//输入三个参数，以及k值
std::string  Knn(const std::list<data>& set,const data& cmp, const int& k);
int main(){
	int k;
	int n;
	std::list<data> set;


	std::cout << "请输入k值：";
	std::cin >> k;

	std::cout << "请输入总数n：";
	std::cin >> n;
	
	std::cout << "输入数据：" << std::endl;
	for (int i = 0; i < n; i++)
	{
		data a;
		std::cin >> a.name >> a.tall >> a.size;
		set.push_back(a);
	}

	std::cout << "输入待确定数据：" << std::endl;
	data cmp;
	std::cin >> cmp.name >> cmp.tall;

	std::string result=Knn(set, cmp, k);
	std::cout << result;

	return 0;
}

std::string Knn(const std::list<data>& set, const data& cmp, const int& k)
{
	std::list<data> pending_data;
	std::map<std::string, int> result;
	std::string result_string;

	auto set_iterator = set.begin();
	for (int i = 0; i < k; i++, set_iterator++)
	{
		data a = *set_iterator;
		a.difference = std::abs(a.tall - cmp.tall);
		pending_data.push_back(a);
	}

	//根据差值排序，差值小的放前面
	pending_data.sort([](const data& a, const data& b) {
		return a.difference < b.difference;
		});

	while (set_iterator != set.end())
	{
		//比较距离
		double difference = std::abs(set_iterator->tall - cmp.tall);
		if (difference < pending_data.back().difference) {
			pending_data.pop_back();
			data a = *set_iterator;
			a.difference = difference;
			pending_data.push_back(a);
		}
		//根据差值排序，差值小的放前面
		pending_data.sort([](const data& a, const data& b) {
			return a.difference < b.difference;
			});
		set_iterator++;
		for (auto& var : pending_data) {
			std::cout << var.difference << " ";
		}
		std::cout << std::endl;
	}

	//检查结果
	for (auto& var : pending_data)
	{
		result[var.size]++;
	}
	for (auto& var : result) {
		if (var.first == result.begin()->first) {
			result_string = var.first;
		}
		else
		{
			if (var.second > result[result_string]) {
				result_string = var.first;
			}
		}
	}

	return result_string;
}

/*
5
14
李丽	1.5 	矮
吉米	1.92 	高
马大华	1.7	中等
王晓华	1.73	 中等
刘敏	1.6	 矮
张强	1.75	 中等
李秦	1.6	 矮
王壮	1.9	 高
刘冰	1.68	  中等
张喆	1.78  中等
杨毅	1.70 	中等
徐田	1.68 	中等
高杰	1.65 	矮
张晓	1.78	  中等
宜昌 1.74	
*/